-- dx and dy define the separating vector, i.e. the direction and magnitude <<<shape_one>>> has to be moved so that the collision will be resolved. [Note that if one of the shapes is a point shape, the translation vector will be invalid.]
function on_collide(dt, shape_a, shape_b, dx, dy)

-- print('collision')
-- print ('mtv : ', dx, dy)

local p, nme, bullet, wall

	-- assign shape_a
	if shape_a.type == "bullet" then
		bullet = shape_a
	elseif shape_a.type == "player" then
		p = shape_a
	elseif shape_a.type == "enemy" then
		nme = shape_a
	elseif shape_a.type == "pickup" then
		pickup = shape_a
	elseif shape_a.type == "wall" then
		wall = shape_a
	elseif shape_a.type == "repel" then
		repel = shape_a
	end
	
	--assign shape_b
	if shape_b.type == "bullet" then
		bullet = shape_b
	elseif shape_b.type == "player" then
		p = shape_b
	elseif shape_b.type == "enemy" then
		nme = shape_b
	elseif shape_b.type == "pickup" then
		pickup = shape_b
	elseif shape_b.type == "wall" then
		wall = shape_b
	elseif shape_b.type == "repel" then
		repel = shape_b
	end
	
	
	
	-- REPEL HITS BULLET
	if shape_a.type == "bullet" and shape_b.type == "repel" or
		shape_b.type == "bullet" and shape_a.type == "repel" then
		
		Collider:addToGroup("group_repel", bullet) -- once repelled, stop reacting to repel instance. add to group ASAP? 
		bullet.instance:resolveRepel(bullet, dx, dy, repel)
		--print("bullet affected by repel: " .. bullet.instance.id)
		
	end
	
	
	-- REPEL HITS ENEMY
	if shape_a.type == "enemy" and shape_b.type == "repel" or
		shape_b.type == "enemy" and shape_a.type == "repel" then
		
		Collider:addToGroup("group_repel", nme) -- once repelled, stop reacting to repel instance. add to group ASAP? 
		nme.instance:resolveRepel(nme, dx, dy, repel)
		--print("enemy affected by repel: " .. nme.instance.id)
		
	end
	
	

	-- BULLET HITS WALL
	if shape_a.type == "bullet" and shape_b.type == "wall" then
		bullet.instance:resolveCollision(bullet, dx,dy)
	elseif shape_b.type == "bullet" and shape_a.type == "wall" then
		--reverse separating vector because wall is shape_a, and we dont want to move into the wall
		bullet.instance:resolveCollision(bullet, -dx,-dy)	
	end	
	
	-- BULLET HITS ENEMY
	if shape_a.type == "bullet" and shape_b.type == "enemy" or
		shape_b.type == "bullet" and shape_a.type == "enemy" then
			
			-- player bullet hits enemy
			if (bullet.instance.origin == "player") then
				nme.instance:getHit(nme, bullet.instance.damage)						
				bullet.instance:explode(bullet) -- explode spawns explosion, and sets bullet lifespan=0
			end
			
	end			

	
	-- BULLET HITS PLAYER
	if shape_a.type == "bullet" and shape_b.type == "player" or
		shape_b.type == "bullet" and shape_a.type == "player" then
			
			-- enemy bullet hits player
			if (bullet.instance.origin == "enemy") then
				p.instance:getHit(p, bullet)
				bullet.instance:explode(bullet) -- explode spawns explosion, and sets bullet lifespan=0
			end
			
	end	
		
		
	
	-- PLAYER HITS WALL
	if shape_a.type == "player" and shape_b.type == "wall" then
		
			if (shape_b.warp_dir == nil) or (shape_b.collision_effect == nil) then
				p.instance:resolveCollision(p, dx, dy)	
			else
				p.instance:warp(p, shape_b.warp_dir)
			end
	
	elseif shape_b.type == "player" and shape_a.type == "wall" then			

			if (shape_a.warp_dir == nil) or (shape_a.collision_effect == nil) then
				--reverse separating vector because wall is shape_a, and we dont want to move into the wall
				p.instance:resolveCollision(p, -dx,-dy)		
			else
				p.instance:warp(p, shape_a.warp_dir)
			end
		
	end
	
	-- PLAYER HITS ENEMY
	if shape_a.type == "player" and shape_b.type == "enemy" then
		p.instance:resolveCollision(p, dx/2,dy/2)	
		nme.instance:resolveCollision(nme, -dx/2,-dy/2) -- reverse vector because enemy1 is shape_b
		
		
		p.instance:getHit(p, nme)
		
	elseif shape_b.type == "player" and shape_a.type == "enemy" then			
			
		
		p.instance:resolveCollision(p, -dx/2,-dy/2)	-- reverse vector
		nme.instance:resolveCollision(nme, dx/2,dy/2) 
		
		p.instance:getHit(p, nme)
		
	end
	
	
	-- PLAYER HITS PICKUP
	if shape_a.type == "player" and shape_b.type == "pickup" then		
		pickup.instance.health = 0
	elseif shape_b.type == "player" and shape_a.type == "pickup" then			
		pickup.instance.health = 0
	end
	
	
	
	
	-- ENEMY1 HITS WALL
	if shape_a.type == "enemy" and shape_b.type == "wall" then
		nme.instance:resolveCollision(nme, dx,dy)
	elseif shape_b.type == "enemy" and shape_a.type == "wall" then
		--reverse separating vector because wall is shape_a, and we dont want to move into the wall
		nme.instance:resolveCollision(nme, -dx,-dy)	
	end
	
	-- ENEMY1 HITS ENEMY1
	-- this ruins my assign shape_a and assign shape_b variables up above because..
	-- if they are both same type, then 'nme' variable is just overwritten with shape_b every time.
	if shape_a.type == "enemy" and shape_b.type == "enemy" then
		--nme.instance:resolveCollision(nme, dx ,dy) -- lols
		shape_a.instance:resolveCollision(shape_a, dx/2, dy/2) -- this seems to work!
		shape_b.instance:resolveCollision(shape_b, -dx/2, -dy/2) -- this seems to work!
	end
	
end
