local class = require 'lib.middleclass'

Explosion = class('Explosion')

function Explosion:initialize(_x, _y, _radius) --originating entity
		
	
	self.x = _x
	self.y = _y
	self.radius = _radius or 5
	self.shockwave = 0
	self.growthrate = 800
	-- maybe give it a hitbox at some point but atm, this is just for the explosion animation / visual
	-- maybe i can reuse it for exploding enemies 
	
	--print ('spawn explosion')
end

function Explosion:drawExplosion()
	
	love.graphics.setColor(128,0,0)		
	love.graphics.circle('fill',self.x, self.y, self.shockwave)
	
end

function Explosion:updateExplosion(i, dt)
			
	self.shockwave = self.shockwave + self.growthrate * dt	
	
	if self.shockwave >= self.radius then
		self:removeExplosion(i)
	end
	
end

function Explosion:removeExplosion(i)  -- index, shape
		
	table.remove(explosions, i)
	-- print ('removed explosion ' .. i )
	
end


return Explosion